#ShadowPara: Parametric Function and Drop Shadow Grapher
#Molly K. Fane --- Fall, 2015 --- Math 198
#Last edited 12/15/2015
#This program graphs a 3D surface using openGL and python. PARAMETRICALLY OH YEAH



#The input is a parametric surface with only real values on the specified domain of u and v
#the input must be python-readable, so you must use pow(u,2) instead of u^2.
#You can also use the functions from math.py, such as math.sin() or math.pi



from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *
import math
import sys

vertices = []
shadowVerts = []
#edges = []


#-----------------------------------------------

#Point of Light coordinates
Lx = 6
Ly = 0
Lz = 25

#Plane definitions
nx = 0
ny = 0
nz = 1
d = -20
planeLength = 30

#define range for v
vInit = 0
vRange = 7
vFin = vInit + vRange
deltaV = .7
v = vInit

#define range for u
uInit = 0
uRange = 7
uFin = uInit + uRange
deltaU = .7
u = uInit

#defines x, y, and z as variables
x = 0
y = 0
z = 0
#following two lines define the index variables of our coordinates-- coor at (vinit,uinit) a = 0 and b = 0
a = 0
b = 0

#INSTRUCTIONS ----- these are printed before the input line comes up
print("ShadowPara: Parametric Function and Drop Shadow Grapher, Molly Fane, Math 198, Fall 2015")
print("")
print("This is a program that graphs a plane, a point of light, a parametric surface, and the resulting drop shadow.")
print("")
print("Please input three functions of the form x= f(u,v), y = g(u,v), and z = h(u,v)")
print("IMPORTANT: Use python and math.py functions in referencing mathematical functions. References include: abs(), math.cos(), math.sinh(), math.sqrt(), math.pi, math.e")
print("IMPORTANT: exponents may be written in two different ways: eg. x to the power of 2 may be written as pow(x,2) or x**2")
print("IMPORTANT: you may NOT devide by zero and you may NOT take the fractional exponant of a negative number")
print("")
print("Examples of functions to look at:")
print("---> Monkey Saddle: x = 'u', y = 'v', z = 'pow(u,3)-3*pow(v,2)*u'")
print("---> Torus: x = '(4+2*math.cos(v))*math.cos(u)', y = '(4+2*math.cos(v))*math.sin(u)', z = '2*math.sin(v)', u and v in [0,7]")
print("---> Klein Bottle:")
print("---> ---> x = '(3+math.cos(v/2)*math.sin(u)-math.sin(v/2)*math.sin(2*u))*math.cos(v)'")
print("---> ---> y = '(3+math.cos(v/2)*math.sin(u)-math.sin(v/2)*math.sin(2*u))*math.sin(v)'")
print("---> ---> z = 'math.sin(v/2)*math.sin(u)+math.cos(v/2)*math.sin(2*u)'")
print("---> ---> u in [-3.5,3.5] and v in [0,7]")
print("---> Mobius Strip: ")
print("---> ---> x = '3*(math.cos(v)+u*math.cos(v/2)*math.cos(v))'")
print("---> ---> y = '3*(math.sin(v)+u*math.cos(v/2)*math.sin(v))'")
print("---> ---> z = '3*u*math.sin(v/2)'")
print("---> ---> u in [-.4,.4] and v in [0,7]")
print("---> Boys Surface:")
print("---> ---> x = '(math.sqrt(2)*pow(math.cos(v),2)*math.cos(2*u)+math.cos(u)*math.sin(2*v))/(2-math.sqrt(2)*math.sin(3*u)*math.sin(2*v))'")
print("---> ---> y = '(math.sqrt(2)*pow(math.cos(v),2)*math.sin(2*u)+math.sin(u)*math.sin(2*v))/(2-math.sqrt(2)*math.sin(3*u)*math.sin(2*v))'")
print("---> ---> z = '(3*pow(math.cos(v),2))/(2-math.sqrt(2)*math.sin(3*u)*math.sin(2*v))'")
print("---> ---> u in [-1.7,1.7] and v in [0,3.5]")
print("")
print("USE QUOTES AROUND THE FUNCTION YOU INPUT!!!! It must be entered as a string.")

#INPUTS
XfuncIn = input("x = ")
YfuncIn = input("y = ")
ZfuncIn = input("z = ")#asks for input function -- MUST USE math.sin, math.cosh... etc!'

print("enter 'N' to not enter RANGES, enter 'Y' or anything else to enter ranges of u and v")
IN = input("enter ranges?   ")
if(IN != 'N'):
    print("enter 'N' if you want to use any of the preset values [preset value in brackets]")#you don't have to enter these
    print("please enter floating point decimal values (floats only, no strings)")
    IN = input("[0] initial u value = ")
    if(IN != 'N'):
        uInit = IN
    IN = input("[7] final u value = ")
    if(IN != 'N'):
        uFin = IN
        uRange = uFin - (uInit)
    IN = input("[.7] deltaU = ")
    if(IN != 'N'):
        deltaU = IN
    IN = input("[0] initial v value = ")
    if(IN != 'N'):
        vInit = IN
    IN = input("[7] final v value = ")
    if(IN != 'N'):
        vFin = IN
        vRange = vFin - vInit
    IN = input("[.7] deltaV = ")
    if(IN != 'N'):
        deltaV = IN
print("enter 'N' to keep default LIGHT COORDINATES or PLANE EQUATION, enter 'Y' or anything else to alter these values")
IN = input("enter LIGHT COORDINATES OR PLANE EQUATION?   ")
if(IN != 'N'):
    print("enter 'N' if you want to use any of the preset values [preset value in brackets]")#you don't have to enter these
    print("please enter floating point decimal values (floats only, no strings)")
    IN = input("[6] Light x coordinate = ")
    if(IN != 'N'):
        Lx = IN
    IN = input("[0] Light y coordinate = ")
    if(IN != 'N'):
        Ly = IN
    IN = input("[25] Light z coordinate = ")
    if(IN != 'N'):
        Lz = IN
    IN = input("[0] Plane Normal Vector x component = ")
    if(IN != 'N'):
        nx = IN
    IN = input("[0] Plane Normal Vector y component = ")
    if(IN != 'N'):
        ny = IN
    IN = input("[1] Plane Normal Vector z component = ")
    if(IN != 'N'):
        nz = IN
    IN = input("[-20] Plane Equaiton: normal*(x,y,z) = d, enter d value")
    if(IN != 'N'):
        d = IN
print("KEYBOARD CONTROLS: Translations: [q][e] [w][s] [a][d] Rotations: [i][k] [u][o] [j][l]")
#END INPUTS

u = uInit
v = vInit
#holds u constant, then draws that trace as v increases by deltaV until v goes from vInit to vFin
#.. then repeats this process for u = u + deltaU until u goes from uInit to uFin

while(u <= deltaU + uFin): #loop to hold u constant and then make a trace in zy-plane and then increase x
    #off by one errors may arise due to float addition inaccuracy
    v = vInit
    b = 0
    while(v <= deltaV + vFin): 
        x = eval(XfuncIn)
        y = eval(YfuncIn)
        z = eval(ZfuncIn)
        vertices.append([x,y,z,a,b])
        v = v + deltaV
        b = b + 1
    u = u + deltaU
    a = a + 1
#---------------------------------------------    
"""def drawEdges():
    vertex = 0
    edge = 0
    glBegin(GL_LINES)
    while(vertex < len(vertices)-1):
        if(vertices[vertex][0]== vertices[vertex+1][0]):
            glVertex3fv(vertices[vertex])
            glVertex3fv(vertices[vertex+1])
        vertex = vertex + 1
    glEnd()"""
def drawQuads(vertsList):
    quadsRendered = 0 #keeps track of the number of quadrilaterals you have mucking every thing up
    aLocal = 0
    bLocal = 0
    glBegin(GL_QUADS)
    glColor3f(0,0,10)
    while(aLocal < math.floor(uRange/deltaU)-1):
        bLocal = 0
        while(bLocal < math.floor(vRange/deltaV)-1):
            #little color edit before the quad is entered
            if(vertsList == vertices):
                lastVertex = searchForAandB(aLocal,bLocal,vertsList)
                glColor3f(1/(abs(.75*lastVertex[2])+1),0,1/(abs(.5*lastVertex[2])+1)) #as z increases, the color darkens --> pretty sweet style.
            if(vertsList == shadowVerts):
               glColor3f(0.0,0.0,0.0) #shadows should be atleast grey
               
            #finds the vertices at the correct indices for the quad to appear correctly
            glVertex3fv(searchForAandB(aLocal,bLocal,vertsList))            
            glVertex3fv(searchForAandB(aLocal+1,bLocal,vertsList))
            glVertex3fv(searchForAandB(aLocal+1,bLocal+1,vertsList))
            glVertex3fv(searchForAandB(aLocal,bLocal+1,vertsList))
            
            quadsRendered = quadsRendered +1
            bLocal = bLocal+1
        aLocal = aLocal+1
    glEnd()
def searchForAandB(aLocal,bLocal,vertsList):
    counter = 0
    while(counter < len(vertsList)-1):
        if(vertsList[counter][3] == aLocal and vertsList[counter][4]== bLocal):
            return [vertsList[counter][0],vertsList[counter][1],vertsList[counter][2]]
        counter = counter + 1

def defineShadow():
    counter = 0
    while(counter < len(vertices)):
        Px = vertices[counter][0]
        Py = vertices[counter][1]
        Pz = vertices[counter][2]
        if(nx*(Px-Lx)+ny*(Py-Ly)+nz*(Pz-Lz) != 0):
            tParameter = .999*(d-nx*Lx-ny*Ly-nz*Lz)/(nx*(Px-Lx)+ny*(Py-Ly)+nz*(Pz-Lz))#there was a float error here that was fixed with using 1.* (...)making the whole expression as a float
            Sx = (Px-Lx)*tParameter + Lx
            Sy = (Py-Ly)*tParameter + Ly
            Sz = (Pz-Lz)*tParameter + Lz
            shadowVerts.append([Sx,Sy,Sz,vertices[counter][3],vertices[counter][4]])
            counter = counter +1
        else:
            print("This combination of light, plane and function returns and infinte shadow")
            sys.exit("Error Message")
            
def drawAxis():
    glBegin(GL_LINES)

    glColor3f(1.0,0.0,0.0)
    glVertex3f(0-uRange/2,0,0)#sets x axis
    glVertex3f(uRange/2,0,0)

    glColor3f(0.0,1.0,0.0)
    glVertex3f(0,0-uRange/2,0)#sets y axis
    glVertex3f(0,uRange/2,0)

    glColor3f(0.0,0.0,1.0)
    glVertex3f(0,0,0-uRange/2)#sets z axis
    glVertex3f(0,0,uRange/2)

    glColor3f(1.0,1.0,1.0)

    glEnd()

def drawPlane():
    glBegin(GL_QUADS)
    glColor3f(0.721568,.721568,0.721568)
    glVertex3f(planeLength/2,planeLength/2,(d-(planeLength/2)*nx-(planeLength/2)*ny)/nz)
    glVertex3f(planeLength/2,-planeLength/2,(d-(planeLength/2)*nx-(-1*planeLength/2)*ny)/nz)
    glVertex3f(-planeLength/2,-planeLength/2,(d-(-1*planeLength/2)*nx-(-1*planeLength/2)*ny)/nz)
    glVertex3f(-planeLength/2,planeLength/2,(d-(-1*planeLength/2)*nx-(planeLength/2)*ny)/nz)
    glEnd()

#This code just makes an asterisk in the sky at point (Lx,Ly,Lz)
def drawLight():
    dL = .1
    glBegin(GL_LINES)
    glColor3f(1,1,0)
    
    #variables got mixed up a little
    #pX, pY, and pZ are local and are the same as global values Lx, Ly, Lz
    pX = Lx
    pY = Ly
    pZ = Lz

    glVertex3f(pX-dL,pY-dL,pZ)
    glVertex3f(pX+dL,pY+dL,pZ)

    glVertex3f(pX+dL,pY-dL,pZ)
    glVertex3f(pX-dL,pY+dL,pZ)

    glVertex3f(pX-dL,pY,pZ)
    glVertex3f(pX+dL,pY,pZ)

    glVertex3f(pX,pY-dL,pZ)
    glVertex3f(pX,pY+dL,pZ)

    glVertex3f(pX,pY-dL,pZ-dL)
    glVertex3f(pX,pY+dL,pZ+dL)

    glVertex3f(pX,pY-dL,pZ+dL)
    glVertex3f(pX,pY+dL,pZ-dL)

    glVertex3f(pX,pY,pZ-dL)
    glVertex3f(pX,pY,pZ+dL)

    glVertex3f(pX-dL,pY,pZ-dL)
    glVertex3f(pX+dL,pY,pZ+dL)

    glVertex3f(pX+dL,pY,pZ-dL)
    glVertex3f(pX-dL,pY,pZ+dL)


    glEnd()
def KeyBoardControls(key,x,y):
    #Keyboard rotate object controls
    
        #ROTATE ABOUT X AXIS
        if(key == "i"):
            glRotatef(-1,1,0,0)
        if(key == "k"):
            glRotatef(1,1,0,0)
            
        #ROTATE ABOUT Y AXIS    
        if(key == "j"):
            glRotatef(-.5,0,1,0)
        if(key == "l"):
            glRotatef(.5,0,1,0)

        #ROTATE ABOUT Z AXIS    
        if(key == "u"):
            glRotatef(.5,0,0,1)
        if(key == "o"):
            glRotatef(-.5,0,0,1)

        #TRANSLATE ALONG Z AXIS    
        if(key == "w"):#W KEY
            glTranslatef(0.0,0.0, -.1)
        if(key == "s"):#S KEY
            glTranslatef(0.0,0.0, .1)

        #TRANSLATE ALONG Y AXIS    
        if(key == "a"):#A KEY
            glTranslatef(0.0,.1,0.0)
        if(key == "d"):#D KEY
            glTranslatef(0.0,-.1, 0.0)

        #TRANSLATE ALONG X AXIS    
        if(key == "q"):#Q KEY
            glTranslatef(.1,0.0,0.0)
        if(key == "e"):#E KEY
            glTranslatef(-.1,0.0, 0.0)
    

def idle():
    glutPostRedisplay()

def main():
    defineShadow()
    glutInit(sys.argv)
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH)
    display = (1000,800)
    glutInitWindowSize(display[0],display[1])
    glutCreateWindow("ShadowPara by Molly K. Fane, Math 198, Fall 2015")
    glutDisplayFunc(draw)
    gluPerspective(45, (display[0]/display[1]), 0.1, 100.0)
    glEnable(GL_DEPTH_TEST)
    glTranslatef(0.0,0.0,-20)
    glRotatef(-45,1,0,0)
    glRotatef(15,0,0,1)
    glutIdleFunc(idle)
    glutKeyboardFunc(KeyBoardControls)
    glutMainLoop()

def draw():    
    glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT)
    drawQuads(vertices)
    drawQuads(shadowVerts)
    #drawEdges()
    drawAxis()
    drawPlane()
    drawLight()
    glutSwapBuffers()

main()


